;Ogre Assimp Viewer 0.99
;Contributeur : falsam 
;Remerciement  comtois pour son aide pour le calcul de la taille d'un mesh

EnableExplicit

Enumeration Font
  #GlobalFont  
EndEnumeration

Enumeration Window
  #MainForm
EndEnumeration

Enumeration Gadgets
  #MeshName
  #MeshSelect
  
  #TextureName
  #TextureSelect
  
  #MaterialName
  #MaterialSelect
  #MaterialRotate
  #MaterialScrollX
  #MaterialScrollY
  #MaterialAlphaBlend
  
  #MaterialWidth
  #MaterialHeight
  #MaterialDepth
  
EndEnumeration

Enumeration Engine
  #Camera
  #Light
  
  #Texture
  #Mesh
  #Entity
 
EndEnumeration

;Evenement windows
Define.l Event, Wevent, GEvent, MEvent, Tevent, TIEvent

Global Light.i, Texture.i, Material.i, Mesh.i, Entity.i
Global Camera.i, CamX.f, CamY.f, CamZ.f
Global RotX.f, RotY.f, RotZ.f

;Calcul dimension d'un mesh
Global Dim MeshData.PB_MeshVertex(0), XMin.f, XMax.f, Ymin.f, YMax.f, ZMin.f, ZMax.f
Global Width.f, Height.f, Depth.f, Radius.f

;Excution OrgreAssimpConverter
Global OgreImport.i, ImportLog.s


Procedure Reset()
  If IsEntity(Entity)
    ClearScreen(RGB(0, 0, 0))
    FreeEntity(Entity)
  EndIf
  
  If IsTexture(Texture)
    FreeTexture(Texture)
  EndIf
  
  If IsMaterial(Material)
    FreeMaterial(Material)
  EndIf
    
  If IsMesh(Mesh)
    FreeMesh(Mesh)
  EndIf
  
  Texture = 0
  material = 0
  Mesh = 0
  Entity = 0
  
  
  SetGadgetText(#MeshName, "")
  SetGadgetText(#MaterialWidth, "0.00")
  SetGadgetText(#MaterialHeight, "0.00")
  SetGadgetText(#MaterialDepth, "0.00")
  
  SetGadgetText(#TextureName, "")
  SetGadgetText(#MaterialName, "")
  
  SetGadgetText(#MaterialRotate, "0")
  SetGadgetText(#MaterialRotate, "0")
  SetGadgetText(#MaterialScrollX, "0")
  SetGadgetText(#MaterialScrollY, "0")
  
  DisableGadget(#materialRotate, #True)
  DisableGadget(#MaterialScrollX, #True)
  DisableGadget(#MaterialScrollY, #True)
  
  DisableGadget(#MaterialAlphaBlend, #True)
  SetGadgetState(#MaterialAlphaBlend, #PB_Checkbox_Unchecked)
EndProcedure

;
; IsNumeric() by SFSxOI 
Procedure IsNumeric(in_str.s) ; whole number - or - floats - with - single decimal point or comma
  Protected rex_IsNumeric, Is_Numeric.b
  
  in_str = RemoveString(in_str, "-")
  
  rex_IsNumeric = CreateRegularExpression(#PB_Any,"^\d*(\.|,)?\d*+$") ; Any digit 0-9, and float - with or without comma or decimal point
  Is_Numeric = MatchRegularExpression(rex_IsNumeric, in_str)
  FreeRegularExpression(rex_IsNumeric) ; if needed or desired - regular expression freed when program ends anyway
  ProcedureReturn Is_Numeric
EndProcedure

;
;Convertir les fichiers Wave Front ou 3DS vers Ogre mesh
Procedure.s OgreAssimpConverter(File.s)
  Protected WorkFile.s, PathFile.s, PartFile.s, ExtFile.s
  
  PathFile = GetPathPart(File)
  PartFile = GetFilePart(File)
  ExtFile = GetExtensionPart(File)
  Partfile = Left(Partfile, Len(Partfile)-Len(ExtFile)-1)
  
  Workfile = "workfile."+ExtFile
  
  CopyFile(File, GetCurrentDirectory()+WorkFile)
  
  OgreImport = RunProgram("OgreAssimpConverter.exe ", WorkFile, "", #PB_Program_Open | #PB_Program_Read | #PB_Program_Hide)
  
  If OgreImport
    While ProgramRunning(OgreImport)
      If AvailableProgramOutput(OgreImport)
        ImportLog + ReadProgramString(OgreImport) + Chr(13)
      EndIf
    Wend
    ImportLog + Chr(13) + Chr(13)
    
    ImportLog + "Code de retour : " + Str(ProgramExitCode(OgreImport))
    
    CloseProgram(OgreImport)
    DeleteFile(WorkFile, #PB_FileSystem_Force)
  EndIf
  
  ;Creation d'un dossier qui contiendra les fichiers ogres.
  PathFile = PathFile+Partfile+"(Ogre Mesh)\"
  CreateDirectory(PathFile)
  
  If ReadFile(0, "workfile_"+ExtFile+".mesh")
    CloseFile(0)
    CopyFile("workfile_"+ExtFile+".mesh", PathFile+Partfile+".mesh")
    DeleteFile("workfile_"+ExtFile+".mesh", #PB_FileSystem_Force)
  EndIf
  
  If ReadFile(0, "workfile_"+ExtFile+".material")
    CloseFile(0)
    CopyFile("workfile_"+ExtFile+".material", PathFile+Partfile+".material")
    DeleteFile("workfile_"+ExtFile+".material", #PB_FileSystem_Force)
  EndIf
  
  ;Pas de traitement de la generation du skeleton pour le moment
  If ReadFile(0, "workfile_"+ExtFile+".skeleton")
    CloseFile(0)
    ;CopyFile("workfile_"+ExtFile+".skeleton", PathFile+Partfile+".skeleton")
    DeleteFile("workfile_"+ExtFile+".skeleton", #PB_FileSystem_Force)
  EndIf
  

  ProcedureReturn (PathFile+Partfile+".mesh")
EndProcedure


Procedure PrepareMaterial()
  If Texture <> 0
    Material = CreateMaterial(#PB_Any, TextureID(Texture))
  EndIf
    
  If GetGadgetState(#MaterialAlphaBlend) = #PB_Checkbox_Checked
    MaterialBlendingMode(Material, #PB_Material_AlphaBlend)
  Else      
    SetEntityMaterial(Entity, MaterialID(Material))
  EndIf  

  RotateMaterial(Material, Val(GetGadgetText(#MaterialRotate)), #PB_Material_Fixed)  
  
  ScrollMaterial(Material, ValF(GetGadgetText(#MaterialScrollX)), ValF(GetGadgetText(#MaterialScrollY)), #PB_Material_Animated, 0) 
    
  SetEntityMaterial(Entity, MaterialID(Material))

EndProcedure

;
; Slectionner une texture  appliquer sur le mesh
Procedure SelectTexture()
  Protected File.s, PathPart.s, FilePart.s
  
  File = OpenFileRequester("Slectionner une texture","","Images |*.jpg;*.png;*.tga",0)
  
  If File <> ""
    PathPart = GetPathPart(File)
    FilePart = GetFilePart(File)
    SetGadgetText(#TextureName, " "+FilePart)
    Add3DArchive(PathPart, #PB_3DArchive_FileSystem)
    Texture = LoadTexture(#PB_Any, FilePart)
    
    DisableGadget(#materialRotate, #False)
    DisableGadget(#MaterialScrollX, #False)
    DisableGadget(#MaterialScrollY, #False)
  
    DisableGadget(#MaterialAlphaBlend, #False)

    PrepareMaterial()
  EndIf
EndProcedure


Procedure SelectMaterial()
  Protected File.s, PathPart.s, FilePart.s, ExtensionPart.s
  
  File = OpenFileRequester("Slectionner un materiel","","Material |*.material",0)
  
  If File <> ""
    PathPart = GetPathPart(File)
    FilePart = GetFilePart(File)
    ExtensionPart = GetExtensionPart(File)
    SetGadgetText(#MaterialName, FilePart)
    Add3DArchive(PathPart, #PB_3DArchive_FileSystem)
    Parse3DScripts() 
    SetGadgetText(#MaterialName, Left(FilePart, Len(FilePart)-Len(ExtensionPart)-1))
    Material = GetScriptMaterial(#PB_Any, GetGadgetText(#MaterialName))
    If Material
      SetEntityMaterial(Entity, MaterialID(Material))
      DisableGadget(#materialRotate, #False)
      DisableGadget(#MaterialScrollX, #False)
      DisableGadget(#MaterialScrollY, #False)
      DisableGadget(#MaterialAlphaBlend, #False)
    Else
      MessageRequester("Ogre Assimp Viewer", "Material not load")
      SetGadgetText(#MaterialName, "")
    EndIf
  EndIf
  
EndProcedure


Procedure SelectModel()
  Protected File.s, PathPart.s, FilePart.s, ExtensionPart.s, i.l, j.l, Model.s, z.i
  
  File = OpenFileRequester("Slectionner un mesh","","Mesh (.mesh .obj .3ds .dae)|*.mesh;*.obj;*.3ds;*.dae",0)
  
  If File <> ""
    
    PathPart = GetPathPart(File)
    FilePart = GetFilePart(File)
    ExtensionPart = GetExtensionPart(File)
    
    SetGadgetText(#MeshName, FilePart)
    
    ;-OgreAssimpConverter si "obj" ou "3ds"
    If ExtensionPart = "obj" Or ExtensionPart = "3ds" Or ExtensionPart = "dae"
      FilePart = OgreAssimpConverter(File)
    EndIf
                          
    Add3DArchive(PathPart, #PB_3DArchive_FileSystem)
    
    Mesh = LoadMesh(#PB_Any, FilePart)
        
    ;-Calcul largeur, hauteur et profondeur (Ne fonctionne pas avec certains meshs)
    If IsMesh(Mesh)
      XMin=0
      XMax=0
      Ymin=0
      YMax=0
      ZMin=0
      ZMax=0
      
      ReDim MeshData.PB_MeshVertex(0)
      
      
      For j=0 To SubMeshCount(Mesh)-1
        GetMeshData(Mesh, j, MeshData(), #PB_Mesh_Vertex|#PB_Mesh_Color, 0, MeshVertexCount(Mesh, j)-1)
      
        For i = 0 To ArraySize(MeshData())
          If MeshData(i)\x < XMin
            Xmin = MeshData(i)\x
          EndIf
        
          If MeshData(i)\x > XMax
            XMax = MeshData(i)\x
          EndIf
        
          If MeshData(i)\y < YMin
            Ymin = MeshData(i)\Y
          EndIf
        
          If MeshData(i)\y > YMax
            YMax = MeshData(i)\y
          EndIf
        
          If MeshData(i)\z < ZMin
            Zmin = MeshData(i)\Z
          EndIf
        
          If MeshData(i)\z > ZMax
            ZMax = MeshData(i)\Z
          EndIf  
        Next
      Next
      
      ;Affichage des dimensions du mesh
      Width  = XMax-Xmin
      Height = YMax-Ymin
      Depth  = ZMax-Zmin
      Radius = MeshRadius(Mesh)
      
      SetGadgetText(#MaterialWidth, StrF(Width, 2))
      SetGadgetText(#MaterialHeight, StrF(Height, 2))
      SetGadgetText(#MaterialDepth, StrF(Depth, 2))
      
      ;-Creation entit 
      Entity = CreateEntity(#PB_Any, MeshID(Mesh),  #PB_Material_None)
      
      ;-Positionnement Camera et lumiere
      If XMax-Xmin > YMax-Ymin
        z = XMax-Xmin
      Else
        z = YMax-Ymin
      EndIf
      
      MoveLight(#Light, 0, (YMax-Ymin)*2, z*2)       
      MoveCamera(#Camera, 0, EntityY(Entity), z*2, #PB_Absolute)
      CameraLookAt(#Camera, 0, 0, 0)
    
    EndIf
  EndIf
EndProcedure

;Initialisation 3D
;Fenetre l'application
Procedure Start()
  
  ;-Init engine
  If Not (InitEngine3D() And InitKeyboard() And InitSprite())
    End
  EndIf
  
  ;-Fenetre
  LoadFont(#GlobalFont, "Arial", 9)

  SetGadgetFont(#PB_Default, FontID(#GlobalFont))
  OpenWindow(#MainForm,0, 0, 440, 600, "Ogre Assimp Viewer", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    
  TextGadget(#PB_Any, 20, 340, 50, 20, "Mesh")
  TextGadget(#MeshName, 150, 340, 200, 22, "test", #PB_Text_Border)
  SetGadgetColor(#MeshName, #PB_Gadget_BackColor, RGB(255, 255, 255))
  ButtonGadget(#MeshSelect, 360, 340, 60, 22, "Select")
  
  TextGadget(#PB_Any, 150, 370, 40, 20, "Size")
  TextGadget(#MaterialWidth, 190, 370, 50, 22, "", #PB_Text_Border) ;Width
  SetGadgetColor(#MaterialWidth, #PB_Gadget_BackColor, RGB(255, 255, 255))
  
  TextGadget(#MaterialHeight, 245, 370, 50, 22, "", #PB_Text_Border) ;Height
  SetGadgetColor(#MaterialHeight, #PB_Gadget_BackColor, RGB(255, 255, 255))

  TextGadget(#MaterialDepth, 300, 370, 50, 22, "", #PB_Text_Border) ;Lenght
  SetGadgetColor(#MaterialDepth, #PB_Gadget_BackColor, RGB(255, 255, 255))
  
  TextGadget(#PB_Any, 20, 440, 50, 20, "Texture")
  TextGadget(#TextureName, 150, 440, 200, 22, "Texture", #PB_Text_Border)
  SetGadgetColor(#TextureName, #PB_Gadget_BackColor, RGB(255, 255, 255))
  ButtonGadget(#TextureSelect, 360, 440, 60, 22, "Select")
  
  TextGadget(#PB_Any, 20, 475, 50, 20, "Material")
  TextGadget(#MaterialName, 150, 475, 200, 22, "material", #PB_Text_Border)
  SetGadgetColor(#MaterialName, #PB_Gadget_BackColor, RGB(255, 255, 255))
  ButtonGadget(#MaterialSelect, 360, 475, 60, 22, "Select")
  
  TextGadget(#PB_Any, 150, 518, 59, 20, "Rotate")
  StringGadget(#materialRotate, 195, 515, 40, 22, "0")
  SetGadgetColor(#MaterialName, #PB_Gadget_BackColor, RGB(255, 255, 255))  
  
  TextGadget(#PB_Any, 240, 518, 44, 20, "ScrollX")
  StringGadget(#MaterialScrollX, 285, 515, 40, 22, "0")
  SetGadgetColor(#MaterialScrollX, #PB_Gadget_BackColor, RGB(255, 255, 255))  
  
  TextGadget(#PB_Any, 334, 518, 44, 20, "ScrollY")
  StringGadget(#MaterialScrollY, 380, 515, 40, 22, "0")
  SetGadgetColor(#MaterialScrollY, #PB_Gadget_BackColor, RGB(255, 255, 255))  
  
  CheckBoxGadget(#MaterialAlphaBlend, 150, 555, 200, 22, "Material AlphaBlend")
  
  TextGadget(#PB_Any, 5, 580, 430, 22, "Rotate: Left, Right, Up, Down   -   Camera: PageUp, PageDown   -   Zoom: - , +")
             
  ;-Fenetre 3D
  OpenWindowedScreen(WindowID(#MainForm),20, 20, 400, 300)
  AmbientColor(RGB(245, 245, 220))
  CreateLight(#Light,RGB(151, 251, 151), -200, 200, 200)
  WorldShadows(#PB_Shadow_Additive) 
  CreateCamera(#Camera,0,0,100,100)
  CameraBackColor(#Camera, RGB(213, 220, 218))
  FrameGadget(#PB_Any, 10, 3, 420, 328, "Preview 3D 3D")
  Reset()
EndProcedure

;-Ca commence ici
Start()

;-Boucle evnementielle
Repeat
  Repeat ;-Evenement Window
    
    Event   = WindowEvent()
    WEvent  = EventWindow()
    GEvent  = EventGadget()
    MEvent  = EventMenu()
    TEvent  = EventType()
    TIEvent = EventTimer()

    Select Event
      Case #PB_Event_Gadget
        Select GEvent
          Case #MeshSelect
            Reset()
            SelectModel()
            
          Case #TextureSelect
            SelectTexture()
            
          Case #MaterialSelect 
            SelectMaterial()
            
          Case #MaterialRotate
            Select TEvent
              Case #PB_EventType_LostFocus
                If Not IsNumeric(GetGadgetText(GEvent)) Or
                   FindString(GetGadgetText(GEvent), "-") Or 
                   ValF(GetGadgetText(GEvent)) > 360
                  SetGadgetColor(GEvent, #PB_Gadget_BackColor, RGB(255, 0, 0))
                  SetActiveGadget(GEvent)
                Else
                  SetGadgetColor(GEvent, #PB_Gadget_BackColor, RGB(255, 255, 255))
                  PrepareMaterial()
                EndIf      
            EndSelect            
                            
          Case #MaterialScrollX, #MaterialScrollY
            Select TEvent                
              Case #PB_EventType_Focus
                
              Case #PB_EventType_LostFocus
                If Not IsNumeric(GetGadgetText(GEvent)) Or
                   FindString(GetGadgetText(GEvent), "-") Or 
                   ValF(GetGadgetText(GEvent)) > 360 Or ValF(GetGadgetText(GEvent)) < -360
                  SetGadgetColor(GEvent, #PB_Gadget_BackColor, RGB(255, 0, 0))
                  SetActiveGadget(GEvent)
                Else
                  SetGadgetColor(GEvent, #PB_Gadget_BackColor, RGB(255, 255, 255))
                  PrepareMaterial()
                EndIf      
            EndSelect            
            
          Case #MaterialAlphaBlend
            PrepareMaterial()
            
        EndSelect
        
        
      Case #PB_Event_CloseWindow
        End
          
    EndSelect
  Until Event = 0 
  
  ;-Evenement 3D
  ExamineKeyboard() 
    
  If Event = #PB_Event_CloseWindow Or KeyboardPushed(#PB_Key_Escape)
    Break
  EndIf   
  
  If IsEntity(Entity)
    If KeyboardPushed(#PB_Key_Left)
      RotY = -0.7     
    ElseIf KeyboardPushed(#PB_Key_Right)
      RotY = 0.7
    Else
      RotY = 0
    EndIf
  
    If KeyboardPushed(#PB_Key_Up)
      RotX = -0.7  
    ElseIf KeyboardPushed(#PB_Key_Down)
      RotX = 0.7  
    Else
      RotX = 0
    EndIf
    
    If KeyboardPushed(#PB_Key_PageUp)
      CamY = Height/100
    ElseIf KeyboardPushed(#PB_Key_PageDown)
      CamY = -Height/100
    Else
      CamY = 0
    EndIf
    
    If KeyboardPushed(#PB_Key_Add)
      CamZ = -Depth/100
    ElseIf KeyboardPushed(#PB_Key_Subtract)
      CamZ = Depth/100
    Else
      CamZ = 0
    EndIf
    
    MoveCamera(Camera, CamX, CamY, CamZ, #PB_Relative)
    RotateEntity(Entity, RotX, RotY, 0, #PB_Relative)
    
  EndIf
  
  FlipBuffers() 
  ClearScreen(RGB(0, 0, 0))
  RenderWorld()  
ForEver
; IDE Options = PureBasic 5.20 LTS (Windows - x86)
; CursorPosition = 251
; FirstLine = 248
; Folding = ---------
; EnableXP
; UseIcon = logo.ico
; Executable = Ogre Assimp Viewer.exe
; SubSystem = OpenGl